//pl0错误诊断处理的验证程序
// 要点：
//    1.为简单起见，pl0程序编译器部分的验证也只限于合法的pl0程序。如果pl0程序不合法（存在语法或语义错误），程序直接退出；
//     2 因此，本文件有2个函数：函数error打印错误信息；函数test在程序不合法时退出程序。
// 关键字：变量不变式、宏定义
#include <stdio.h>
#include "specification.h"

void error(const long n){
    long i;
    printf("%s\n", " ****");
    //@ loop invariant 0 <= cc <= ll && 1 <= i <= cc && 0 < cc <= 80 && 0 < ll <= 80;
    for (i=1; i<=cc-1; i++){
        printf("%s", " ");
    }
    printf("^%2ld\n",n);
    if(err < errmax) {
        err++;
    } else {
        //@ ghost too_many_error = true;
        exit(1);
    }
}


void test(long s1, long const s2, long n){
    if ((sym & s1) == 0){
        error(n);
        s1=s1|s2;
        /*@ loop invariant (\old(sym) & \old(s1)) == 0 && s1 == (\old(s1) | s2) && currentCodeLineAndExtra && \old(sym)== sym; */
        while((sym & s1) == 0){    // 把多余的符号忽略掉
            //@ ghost stop_here = true;
            exit(2);         // 增加该语句是为了避免验证错误恢复功能。
            // getsym();    // 删除该语句，以免报告出现不可及代码。
        }
    }
} 
